class BaseConfig():
    def __init__(
            self,
            size_x=10,
            size_y=10,
            stride=5,
            threshold=500,
            grid_size=0.02,
            normal_radius=0.8,
            train_batch_size=12,
            test_batch_size=64,
            num_points = 1024,
            num_workers=4,
            epoch=201,
            pretrain=None,
            init_epoch=0,
            gpu='0',
            learning_rate=0.001,
            step_size=16,  # 20 for learning rate 0.001
            gamma=0.5,  # 0.5 for learning rate 0.001,
            decay_rate=1e-4,
            optimizer='Adam',
            multi_gpu='0,1,2,3',
            train_split='train',
            test_split='test',
            debug=False,
            print_batch=10,
            dataset = None,
            train_data_dir=None,
            test_data_dir=None,
            num_classes=0,
            in_channels=3,
            validation=True,
            model_name=None,
            visual_dir='experiment/pred/visual',
            info='default'
    ):
        self.size_x = size_x
        self.size_y = size_y
        self.stride = stride
        self.threshold = threshold
        self.grid_size = grid_size
        self.normal_radius = normal_radius
        self.train_batch_size = train_batch_size
        self.test_batch_size = test_batch_size
        self.num_points = num_points
        self.workers = num_workers
        self.epoch = epoch
        self.pretrain = pretrain
        self.init_epoch = init_epoch
        self.gpu = gpu
        self.learning_rate = learning_rate
        self.step_size = step_size
        self.gamma = gamma
        self.decay_rate = decay_rate
        self.optimizer = optimizer
        self.multi_gpu = multi_gpu
        self.train_split = train_split
        self.test_split = test_split
        self.debug = debug
        self.model_name = model_name
        self.dataset = dataset
        self.train_data_dir = train_data_dir
        self.test_data_dir = test_data_dir
        self.num_classes = num_classes
        self.in_channels = in_channels
        self.print_batch = print_batch
        self.validation = validation
        self.visual_dir = visual_dir
        self.num_workers = num_workers
        self.info = info
